// license-header java merge-point
//
/**
 * @author Generated on 09/08/2012 01:23:22-0400 Do not modify by hand!
 *
 * TEMPLATE:     ValueObject.vsl in andromda-java-cartridge.
 * MODEL CLASS:  org::andromda::samples::carrental::inventory::CarData
 * STEREOTYPE:   ValueObject
 */
package org.andromda.samples.carrental.inventory;

import java.io.Serializable;
import java.util.Arrays;
import org.apache.commons.lang.builder.CompareToBuilder;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;

/**
 * <p>
 * This Value Object is used to send information of a car
 * </p>
 */
public class CarData
    implements Serializable, Comparable<CarData>
{
    /** The serial version UID of this class. Needed for serialization. */
    private static final long serialVersionUID = -2215278001469594397L;

    // Class attributes
    /** TODO: Model Documentation for attribute registrationNo */
    protected String registrationNo;
    /** TODO: Model Documentation for attribute inventoryNo */
    protected String inventoryNo;

    /** Default Constructor with no properties */
    public CarData()
    {
        // Documented empty block - avoid compiler warning - no super constructor
    }

    /**
     * Constructor with all properties
     * @param registrationNoIn String
     * @param inventoryNoIn String
     */
    public CarData(final String registrationNoIn, final String inventoryNoIn)
    {
        this.registrationNo = registrationNoIn;
        this.inventoryNo = inventoryNoIn;
    }

    /**
     * Copies constructor from other CarData
     *
     * @param otherBean Cannot be <code>null</code>
     * @throws NullPointerException if the argument is <code>null</code>
     */
    public CarData(final CarData otherBean)
    {
        this.registrationNo = otherBean.getRegistrationNo();
        this.inventoryNo = otherBean.getInventoryNo();
    }

    /**
     * Copies all properties from the argument value object into this value object.
     * @param otherBean Cannot be <code>null</code>
     */
    public void copy(final CarData otherBean)
    {
        if (null != otherBean)
        {
            this.setRegistrationNo(otherBean.getRegistrationNo());
            this.setInventoryNo(otherBean.getInventoryNo());
        }
    }

    /**
     * TODO: Model Documentation for attribute registrationNo
     * Get the registrationNo Attribute
     * @return registrationNo String
     */
    public String getRegistrationNo()
    {
        return this.registrationNo;
    }

    /**
     * 
     * @param value String
     */
    public void setRegistrationNo(final String value)
    {
        this.registrationNo = value;
    }

    /**
     * TODO: Model Documentation for attribute inventoryNo
     * Get the inventoryNo Attribute
     * @return inventoryNo String
     */
    public String getInventoryNo()
    {
        return this.inventoryNo;
    }

    /**
     * 
     * @param value String
     */
    public void setInventoryNo(final String value)
    {
        this.inventoryNo = value;
    }

    /**
     * @param object to compare this object against
     * @return boolean if equal
     * @see Object#equals(Object)
     */
    @Override
    public boolean equals(final Object object)
    {
        if (object==null || object.getClass() != this.getClass())
        {
             return false;
        }
        // Check if the same object instance
        if (object==this)
        {
            return true;
        }
        CarData rhs = (CarData) object;
        return new EqualsBuilder()
            .append(this.getRegistrationNo(), rhs.getRegistrationNo())
            .append(this.getInventoryNo(), rhs.getInventoryNo())
            .isEquals();
    }

    /**
     * @param object to compare this object against
     * @return int if equal
     * @see Comparable#compareTo(Object)
     */
    public int compareTo(final CarData object)
    {
        if (object==null)
        {
            return -1;
        }
        // Check if the same object instance
        if (object==this)
        {
            return 0;
        }
        return new CompareToBuilder()
            .append(this.getRegistrationNo(), object.getRegistrationNo())
            .append(this.getInventoryNo(), object.getInventoryNo())
            .toComparison();
    }

    /**
     * @return int hashCode value
     * @see Object#hashCode()
     */
    @Override
    public int hashCode()
    {
        return new HashCodeBuilder(1249046965, -82296885)
            .append(this.getRegistrationNo())
            .append(this.getInventoryNo())
            .toHashCode();
    }

    /**
     * @return String representation of object
     * @see Object#toString()
     */
    @Override
    public String toString()
    {
        return new ToStringBuilder(this)
            .append("registrationNo", this.getRegistrationNo())
            .append("inventoryNo", this.getInventoryNo())
            .toString();
    }

    /**
     * Compares the properties of this instance to the properties of the argument. This method will return
     * {@code false} as soon as it detects that the argument is {@code null} or not of the same type as
     * (or a sub-type of) this instance's type.
     *
     * <p/>For array, collection or map properties the comparison will be done one level deep, in other words:
     * the elements will be compared using the {@code equals()} operation.
     *
     * <p/>Note that two properties will be considered equal when both values are {@code null}.
     *
     * @param thatObject the object containing the properties to compare against this instance
     * @return this method will return {@code true} in case the argument has the same type as this class, or is a
     *      sub-type of this class and all properties as found on this class have equal values when queried on that
     *      argument instance; in all other cases this method will return {@code false}
     */
    public boolean equalProperties(final Object thatObject)
    {
        if (thatObject == null || !this.getClass().isAssignableFrom(thatObject.getClass()))
        {
            return false;
        }

        final CarData that = (CarData)thatObject;

        return
            equal(this.getRegistrationNo(), that.getRegistrationNo())
            && equal(this.getInventoryNo(), that.getInventoryNo())
        ;
    }

    /**
     * This is a convenient helper method which is able to detect whether or not two values are equal. Two values
     * are equal when they are both {@code null}, are arrays of the same length with equal elements or are
     * equal objects (this includes {@link java.util.Collection} and {@link java.util.Map} instances).
     *
     * <p/>Note that for array, collection or map instances the comparison runs one level deep.
     *
     * @param first the first object to compare, may be {@code null}
     * @param second the second object to compare, may be {@code null}
     * @return this method will return {@code true} in case both objects are equal as explained above;
     *      in all other cases this method will return {@code false}
     */
    protected static boolean equal(final Object first, final Object second)
    {
        final boolean equal;

        if (first == null)
        {
            equal = (second == null);
        }
        else if (first.getClass().isArray() && (second != null) && second.getClass().isArray())
        {
            equal = Arrays.equals((Object[])first, (Object[])second);
        }
        else // note that the following also covers java.util.Collection and java.util.Map
        {
            equal = first.equals(second);
        }

        return equal;
    }

    // CarData value-object java merge-point
}